/* LinkStorm menu banner plugin */
(function (pluginName){
	new adriver.Plugin(pluginName);

	if (!('addDiv' in adriver)) adriver.prototype.addDiv = function(o, params, inner){
		var n = document.createElement("DIV");
		adriver.extend(n.style, params);
		if (o) o.appendChild(n);
		if (inner) n.innerHTML = inner;

		return n;
	}

	adriver.menuBanner = {
		timer: 0,
		timer2: 0,
		timer3: 0,
		prefixes: {},
		timeout: 500,
		rndRep: function(s,rnd){return s.replace(/!\[rnd\]/g, rnd)},
		createCss: function(a, src){
			src = src.replace(/!\[rnd\]/g, a.reply.rnd);
			src = (/^http:\/\//i.test(src) ? '' : a.reply.comppath) + src;

			var link = document.getElementsByTagName('head')[0].appendChild(document.createElement('link'));
			link.rel = "stylesheet";
			link.type = "text/css";
			link.href = src;
		},
		createMenu: function(a, holder, menu, prefix){
			var d = a.addDiv(holder, {});
			d.className = 'adriver_menu';
			for (var i=0; i<menu.length; i++) this.createMenuItem(a, d, menu[i], prefix+'_'+(i+1));

			return d
		},
		createMenuItem: function(a, holder, item, prefix){
			var _ = this, d = a.addDiv(holder, {}, item.text);
			d.onmouseover = function(e){_.showMenu(a, this, prefix)}
			d.onmouseout = function(){_.hideMenu();this.className = this.className.replace('Over','')}

			if (item.click){
				d.className = 'adriver_click';
				d.onclick = function(){
					var link = _.rndRep(_.click, _.prefixes[prefix]) + '&sz=' + prefix + '&rleurl=' + escape(item.click);
					switch(a.reply.target){
						case '_top': top.location.href = link; break;
						case '_blank':
						default: window.open(link, '_blank'); break;
					}
				}
			}
			if (item.menu) this.createMenu(a, d, item.menu, prefix);

			d.className += ' ' + item.className;

			return d
		},
		showMenu: function(a, item, prefix){
			var _ = this;
			clearTimeout(this.timer);
			this.timer2 = setTimeout(function(){
				if (!(prefix in _.prefixes)){
					_.prefixes[prefix] = Math.round(Math.random()*999999999);
					a.sendPixel(_.rndRep(_.rle, _.prefixes[prefix]) + '&sz=' + prefix);
				}
			},300);
			item.className = item.className.replace('Over','') + 'Over';
		},
		hideMenu: function(){
			var _ = this;
			clearTimeout(_.timer);
			clearTimeout(_.timer2);
			_.timer = setTimeout(function(){
				_.menu.className = _.menu.className.replace('Over','')
			}, _.timeout);
		},
		draw: function(a, img, swf, width, height, wmode, flashver, align, pixel, css, menu, rle, click){
			a.sendPixel(pixel);
			this.rle = rle + '&bn=' + a.reply.bid;
			this.click = click + '&bn=' + a.reply.bid;
			this.createCss(a, css);

			a.p.style.position = 'relative';
			var d1 = a.addDiv(a.p, {position: 'relative', width: width+'px', height: height+'px'}, a.hasFlash(flashver) ? a.makeFlash(swf, {wmode:wmode}) : a.makeImage(img));
			var _ = this;
			d1.onmouseover = function(){
				clearTimeout(_.timer);
				clearTimeout(_.timer3);
				if (!/Over$/.test(_.menu.className)) _.timer3 = setTimeout(function(){
					_.showMenu(a, _.menu, '_')
				},_.timeout)
			}
			d1.onmouseout = function(){clearTimeout(_.timer3);_.hideMenu()}

			this.menu = this.createMenu(a, a.p, menu, '');
			this.menu.className = 'adriver_menu';
			switch(align){
				case '0': adriver.extend(this.menu.style, {left: '0px', bottom: height+'px'});
					break;
				case '1': adriver.extend(this.menu.style, {left: width+'px', top: '0px'});
					break;
				case '2': adriver.extend(this.menu.style, {left: '0px', top: height+'px'});
					break;
				case '3': adriver.extend(this.menu.style, {right: width+'px', top: '0px'});
					break;
				case '4':
				default : d1.onmouseover = function(e){
						clearTimeout(_.timer);
						clearTimeout(_.timer3);

						e = e||event;
						var l = (e.layerX||e.offsetX)+'px',
							t = (e.layerY||e.offsetY)+'px';
						d1.onmousemove = function(E){
							E = E||event;
							l = (E.layerX||E.offsetX)+'px',
							t = (E.layerY||E.offsetY)+'px';
						}

						if (!/Over$/.test(_.menu.className)) _.timer3 = setTimeout(function(){
							_.showMenu(a, _.menu, '_');
							adriver.extend(_.menu.style, {left: l, top: t});
							d1.onmousemove = null;
						},_.timeout)
					}
					break;
			}
		}
	}

	new adriver.Plugin.require("pixel.adriver", "checkFlash.adriver", "makeFlash.adriver", "makeImage.adriver").onLoadComplete(function(){
		adriver.Plugin(pluginName).loadComplete();
	});
})("menuBanner.linkstorm");